%global pkg mellanox
%global kernel 5.10.134-17.an8
%define pkg_version 23.10
%define anolis_release 1
%define debug_package %{nil} 
%undefine _hardened_build
%global VAR1 CONFIG_AUXILIARY_BUS
%global VAR2 CONFIG_AUXILIARY_BUS_MODULE
# %global KERNEL_CONFIG_AUXILIARY_BUS %(tac /usr/src/kernels/%{kernel}.%{_arch}/include/*/autoconf.h | grep -m1 %{VAR1} |  awk '{print $3}')
# %{!?KERNEL_CONFIG_AUXILIARY_BUS: %global KERNEL_CONFIG_AUXILIARY_BUS %(tac /usr/src/kernels/%{kernel}.%{_arch}/include/*/autoconf.h | grep -m1 %{VAR2} |  awk '{print $3}')}
%global KERNEL_CONFIG_AUXILIARY_BUS 1
Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     Mellanox NIC drivers
License:     GPL-v2
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz

Requires: kmod
Requires: dracut
BuildRequires: kernel-devel  = %{kernel}
BuildRequires: gcc kmod elfutils-libelf-devel automake

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
Mellanox(R) NIC adapters 25G

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
#cd mlnx-ofa_kernel-%{pkgversion}/
cd src
./configure --kernel-version=%{kernel}.%{_arch} --kernel-sources=/usr/src/kernels/%{kernel}.%{_arch} \
     --with-core-mod --with-user_mad-mod --with-user_access-mod --with-nvmf_host-mod --with-nvmf_target-mod \
    --with-addr_trans-mod --with-mlx5-mod --with-mlxfw-mod --with-ipoib-mod --without-xdp --with-nfsrdma-mod --with-gds \
    --with-iser-mod --with-isert-mod -j32
sed -i 's/^#define HAVE_FILE_OPERATIONS_URING_CMD_IOPOLL 1/\/\* #undef HAVE_FILE_OPERATIONS_URING_CMD_IOPOLL \*\//' compat/config.h
sed -i 's/^#define HAVE_FILE_OPERATIONS_URING_CMD 1/\/\* #undef HAVE_FILE_OPERATIONS_URING_CMD \*\//' compat/config.h
sed -i 's/^#define HAVE_BLK_RQ_MAP_USER_IO 1/\/\* #undef HAVE_BLK_RQ_MAP_USER_IO \*\//' compat/config.h

make -j32

%install
cd src
make install INSTALL_MOD_PATH=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/infiniband/
cp ofed_scripts/vf-net-link-name.sh $RPM_BUILD_ROOT/etc/infiniband/
mkdir -p $RPM_BUILD_ROOT/lib/udev/rules.d
cp ofed_scripts/82-net-setup-link.rules $RPM_BUILD_ROOT/lib/udev/rules.d/

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    if echo "$kmod" | grep -q "nvme"; then
        continue
    fi
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

# Generate kmod-mellanox-ethernet depmod.conf
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/compat/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/compat/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/compat/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net/ethernet/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/drivers/net/ethernet/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/drivers/net/ethernet/(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net/mlxdevm/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/net/mlxdevm/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/net/mlxdevm/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/base/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/nvme/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-nvme.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-nvme.conf
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    if [ -e "/boot/initramfs-`uname -r`.img" ]; then dracut -f --kver "$kversion" > /dev/null 2>&1 ;fi
done

# find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
for module in mlx_compat.ko mlxfw.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

for module in mlxdevm.ko nvmet-rdma.ko nvme-rdma.ko ib_core.ko ib_ucm.ko erdma.ko mlx4_ib.ko i40iw.ko bnxt_re.ko hfi1.ko efa.ko qedr.ko vmw_pvrdma.ko \
ib_mthca.ko ocrdma.ko usnic_verbs.ko iw_cxgb4.ko rdmavt.ko siw.ko rdma_rxe.ko opa_vnic.ko ib_srp.ko ib_iser.ko ib_srpt.ko mlxsw_spectrum.ko \
smc.ko smc_diag.ko xprtrdma.ko svcrdma.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name mlx5_core.ko | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1

for module in ib_umad.ko ib_uverbs.ko ib_cm.ko iw_cm.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

for module in mlx5_ib.ko ib_ipoib.ko rdma_cm.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

for module in rpcrdma.ko ib_isert.ko rdma_ucm.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

%preun
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
	echo "$module" >> /var/run/rpm-%{pkg}-modules.list
done

%postun
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules > /dev/null 2>&1
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/*
%exclude /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/nvme/
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols
%exclude /lib/modules/%{kernel}.%{_arch}/modules.softdep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.devname
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.alias.bin
/etc/infiniband/openib.conf
/etc/init.d/openibd
/etc/modprobe.d/mlnx.conf
/etc/modprobe.d/ib_ipoib.conf
/usr/sbin/setup_mr_cache.sh
/etc/infiniband/mlx5.conf
/etc/infiniband/vf-net-link-name.sh
/etc/modprobe.d/mlnx-bf.conf
/usr/sbin/ibdev2netdev
/lib/udev/auxdev-sf-netdev-rename
/lib/udev/rules.d/82-net-setup-link.rules
/lib/udev/rules.d/83-mlnx-sf-name.rules
/lib/udev/rules.d/90-ib.rules
/lib/udev/sf-rep-netdev-rename
/usr/share/mlnx_ofed/mlnx_bf_assign_ct_cores.sh
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf


%package -n  kmod-mellanox-ethernet
Summary: kmod-mellanox-ethernet package
Requires: kmod
Provides: kmod-mellanox-ethernet-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-mellanox-ethernet-%{kernel}.%{_arch} < %{version}-%{release}
%description -n kmod-mellanox-ethernet
kmod-mellanox-ethernet package



%post -n  kmod-mellanox-ethernet
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    if [ -e "/boot/initramfs-`uname -r`.img" ]; then dracut -f --kver "$kversion" > /dev/null 2>&1 ;fi
done

find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
%preun  -n  kmod-mellanox-ethernet
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
        echo "$module" >> /var/run/rpm-kmod-mellanox-ethernet-modules.list
done
%postun -n  kmod-mellanox-ethernet

/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    if [ -e "/boot/initramfs-`uname -r`.img" ]; then dracut -f --kver "$kversion" > /dev/null 2>&1 ;fi
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-kmod-mellanox-ethernet-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules > /dev/null 2>&1
fi
rm /var/run/rpm-kmod-mellanox-ethernet-modules.list

%files -n kmod-mellanox-ethernet
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/compat/*
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net/ethernet/*
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net/mlxdevm/*
%if "%{KERNEL_CONFIG_AUXILIARY_BUS}" != "1"
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/base/*
%endif
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/compat
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net/ethernet/
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net/mlxdevm
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/

%package -n kmod-mellanox-nvme
Summary: kmod-mellanox-nvme package
Requires: kmod
Provides: kmod-mellanox-nvme-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-mellanox-nvme-%{kernel}.%{_arch} < %{version}-%{release}
%description -n kmod-mellanox-nvme
kmod-mellanox-nvme package

%post -n  kmod-mellanox-nvme
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    if [ -e "/boot/initramfs-`uname -r`.img" ]; then dracut -f --kver "$kversion" > /dev/null 2>&1 ;fi
done

find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules > /dev/null 2>&1

%preun  -n  kmod-mellanox-nvme
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
        echo "$module" >> /var/run/rpm-kmod-mellanox-nvme-modules.list
done

%postun -n  kmod-mellanox-nvme

/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-kmod-mellanox-nvme-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules > /dev/null 2>&1
fi
rm /var/run/rpm-kmod-mellanox-nvme-modules.list

%files -n kmod-mellanox-nvme
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/nvme/*
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}-nvme.conf
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/nvme/

%changelog
* Sun Jul 28 2024 Guixin Liu <kanie@linux.alibaba.com> - 23.10
- Add kmod-mellanox-nvme build and rpm package

* Thu Jul 25 2024 Bitao Hu <yaoma@linux.alibaba.com> - 23.10
- update spec

* Wed Jul 24 2024 sunyufei <sunyufei.syf@alibaba-inc.com> - 23.10
- Add kmod-mellanox-ethernet build and rpm package

* Wed Jul 10 2024 sunyufei <sunyufei.syf@alibaba-inc.com> - 23.10
- upload src  23.10-2.1.3.1 lts
